#include "list.h"
#include <stdio.h>
#include <stdlib.h>

typedef struct webserver {
  List* requests;
  List* responses;
} webserver;

webserver* create() {
  webserver* r = malloc(sizeof(webserver));
  r->requests = NULL;
  r->responses = NULL;
  return r;
}

void new_request(webserver* w, int data) {
  w->requests = append1(w->requests, from_int(data));
  printf("LOG: received %d\n", data);
}

void process_request(webserver* w) {
  int data;
  w->requests = pop(w->requests, &data);
  int rep_data = data+1;
  printf("LOG: processing %d\n", data);
  w->responses = append1(w->responses, from_int(rep_data));
}

#define INCOMING_RATE 3
#define PROCESSING_RATE 4
int main() {
  webserver* w = create();

  for (int loop=0; loop<3; loop++) {
    for (int i=0; i<INCOMING_RATE; i++) {
      new_request(w, i);
      printf("requests: "); print(w->requests);
    }

    for (int i=0; i<PROCESSING_RATE; i++) {
      process_request(w);
      printf("responses: "); print(w->responses);
    }
  }

}
  
